function [ obj_funct ] = cond_mle_objective_function( param, assum_f_delta, order, linear_case )
% This function generates the objective function to minimize for the
% maximum likelihood problem. The likelihood is conditional since it takes
% b as exogenous.

global k ndep X X_d pop l b p c r num_out n

      ttheta = param(1);
      ppsi_1 = param(2);
      ppsi_2 = param(3:3+num_out-1);
      bbeta_out = param(3+num_out:3+num_out+(num_out*(k+1))-1)';
      zzet_out = param(3+num_out+(num_out*(k+1)):3+num_out+(num_out*(k+1))+(num_out*ndep)-1)';
      pphi = param(3+num_out+(num_out*(k+1))+(num_out*ndep):3+num_out+(num_out*(k+1))+(num_out*ndep)+3-1)';
      bbeta_br = param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1-1)';
      zzet_br = param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1)';
      ssigma=param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep);    
      aalpha=param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep+1);
      sstds = param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep+1+1:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep+1+num_out+1);
      ttau = param(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep+1+num_out+1+1);
     
      
      if assum_f_delta==1                                            % if N(d) depends on delta (the neighbors matrices are assumed to depend on a parameter vector delta)      
        ddelta=param(end-1:end);
      else
        ddelta=ones(2,1);
      end
      
      index = aalpha;
      aalpha = exp(index)./(1 + exp(index));
      
      if linear_case==1
          aalpha=1;  
          ssigma=1;     
      end
      
% neighborhood matrix generated with delta given
NN=neighbors_matrix(ddelta, order); 

% generate state capacity as a weighted average of local and national state presence
if ssigma==1
    s = (l.^aalpha).*((ttau*b).^(1-aalpha));
else
    s = ( (aalpha.*(l.^((ssigma-1)/ssigma))) + ((1-aalpha).*((ttau*b).^((ssigma-1)/ssigma))) ).^(ssigma/(ssigma-1));
end

% index function
biweight_kernel=0;
truncation_normal=10;
nobin=0;
yy = (ttheta./aalpha).*l.*((l./s).^(1/ssigma)) - ppsi_1*(NN*s) - X_d*zzet_br;
xx = [log(1+c) r zscore(X) log(pop)];
g_nonparam = nonparametric_conditional( yy, xx, biweight_kernel, truncation_normal, [pphi; bbeta_br], nobin );

% variables for the likelihood
h_xi = (ttheta./aalpha).*l.*((l./s).^(1/ssigma)) - ppsi_1*(NN*s) - g_nonparam - X_d*zzet_br;

h_eps = zeros(n,num_out);
for j=1:num_out
    h_eps(:,j) = zscore(p(:,j)) - ((ttheta./aalpha).*l.*s.*((l./s).^(1/ssigma))) - (ppsi_2(j).*(NN*s)) - ([zscore(X) pop]*bbeta_out(((j-1)*k)+j:j*(k+1))) - (X_d*zzet_out((1+((j*ndep)-ndep):j*ndep)));
end

U=[h_xi h_eps];

VarCov=[sstds(1)^2 0 0 0 0; 0 sstds(2)^2 0 0 0; 0 0 sstds(3)^2 0 0; 0 0 0 sstds(4)^2 0; 0 0 0 0 sstds(5)^2];

% log likelihood generation

det_J = (ttheta./aalpha).*(1/ssigma).*( ( (1+ssigma).*( (l./s).^(1/ssigma) ) ) - ( aalpha.*(l./s) ) );      %Jacobian term

Sum_log_J= sum(log(abs(det_J))); 

USU = trace((U/VarCov)*(U'));

loglike = -0.5*n*log( ((2*pi)^(num_out+1))*det(VarCov) ) - 0.5*USU + Sum_log_J;

obj_funct = -loglike;

end

