%Estimation of State Capacity Spillovers: SYSTEM GMM
%Acemoglu, Garcia-Jimeno, Robinson

%Descriptive Statistics Table

clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Import data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Open data file State_Capacity_Network_Work.mat
load State_Capacity_Network_Work.mat


%%

%State Capacity

    %Local-level State Agencies
     llsa = S(:,6)+S(:,7)+S(:,8)+S(:,11)+S(:,12)+S(:,13)+S(:,14)+S(:,15)+S(:,16)+S(:,18)+S(:,19);
     llsa= llsa(~isnan(llsa));
     
     llme = S(:,1);
     llme= llme(~isnan(llme));
     
     nlme = S(:,2);
     nlme= nlme(~isnan(nlme));
     
    %Prosperity  
     lqi = Yg(:,10);
     lqi= lqi(~isnan(lqi));
    
     pucr = ((Yg(:,4)+Yg(:,5)+Yg(:,6))/3);
     pucr= pucr(~isnan(pucr));
     
     fpapl = Yg(:,9);
     fpapl= fpapl(~isnan(fpapl));
     
     ser = Yg(:,2);
     ser = ser(~isnan(ser));

	 per = Yg(:,1); 
	 per = per(~isnan(per));	
     per = min(per,1);
     
	 vcr = Yg(:,7);
	 vcr = vcr(~isnan(vcr));
     	
    %Historical Variables
     cso = C(:,1);
     cso= cso(~isnan(cso));
     
     csa = C(:,3);
     csa= csa(~isnan(csa));
     
     drr = R;
     drr = drr(~isnan(drr));
     
     pop1843 = H(:,8);
     pop1843= (pop1843(~isnan(pop1843)))/1000;
     
   %Network Variables
    non = sum(Adj,2);
    non= non(~isnan(non));
    
    gdn = sum((Ddist.*Adj),2);
    gdn = gdn(~isnan(gdn));
    gdn = gdn./non;
    
    gven = sum((Drankvar.*Adj),2);
    gven = gven(~isnan(gven));
    gven = gven./non;
    
    bec = NS(:,1);
    bec = bec(~isnan(bec));
    
    boc = NS(:,2);
    boc = boc(~isnan(boc));
    
    lcc = NS(:,3); 
    lcc = lcc(~isnan(lcc));
    
   %Covariates
    dch = Xs(:,1);
    dch= (dch(~isnan(dch)))/1000;
    
    longi = G(:,1);
    longi= longi(~isnan(longi));
    
    lat = G(:,2);
    lat= lat(~isnan(lat));
    
    sufar = G(:,3);
    sufar= sufar(~isnan(sufar));
    
    elev = G(:,4);
    elev= elev(~isnan(elev));
   
    aar = G(:,5);
    aar= aar(~isnan(aar));
    
    pop = Xs(:,2);
    pop= (pop(~isnan(pop)))/1000;
    
   
   %Means
    means = [mean(llsa) mean(llme) mean(nlme) mean(lqi) mean(pucr) mean(fpapl) mean(ser) mean(per) mean(vcr) mean(cso) mean(csa) mean(drr) mean(pop1843) mean(non) mean(gdn) mean(gven) mean(bec) mean(boc) mean(lcc) mean(dch) mean(longi) mean(lat) mean(sufar) mean(elev) mean(aar) mean(pop)]';
   
   %Medians
    medians = [median(llsa) median(llme) median(nlme) median(lqi) median(pucr) median(fpapl) median(ser) median(per) median(vcr) median(cso) median(csa) median(drr) median(pop1843) median(non) median(gdn) median(gven) median(bec) median(boc) median(lcc) median(dch) median(longi) median(lat) median(sufar) median(elev) median(aar) median(pop)]';
   
   %Standard Deviations
    stdvs = [std(llsa) std(llme) std(nlme) std(lqi) std(pucr) std(fpapl) std(ser) std(per) std(vcr) std(cso) std(csa) std(drr) std(pop1843) std(non) std(gdn) std(gven) std(bec) std(boc) std(lcc) std(dch) std(longi) std(lat) std(sufar) std(elev) std(aar) std(pop)]';
   
   
   disp('Means')
   disp(means)
   
   disp('Medians')
   disp(medians)
   
   disp('Standard Deviations')
   disp(stdvs)
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   