function [ objective_fct_gmm ] = simul_gmm_objective_function( param_gmm, assum_f_delta, truncation_normal, nobin, biweight_kernel, order, num_out, ZOZ, OMEGAS, num_cov_weights, draws )
% This function computes the objective function that is going to be
% minimized in the Simulated GMM approach

global k X p l b pop hpop c r N N_2 X_d ndep d_bar e_bar n V

      ttheta = param_gmm(1);
      ppsi_1 = param_gmm(2);
      ppsi_2 = param_gmm(3:3+num_out-1)';
      bbeta_out = param_gmm(3+num_out:3+num_out+(num_out*(k+1))-1)';
      zzet_out = param_gmm(3+num_out+(num_out*(k+1)):3+num_out+(num_out*(k+1))+(num_out*ndep)-1)';
      pphi = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep):3+num_out+(num_out*(k+1))+(num_out*ndep)+3-1)';
      bbeta_br = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1-1)';
      zzet_br = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1)';
      ssigma = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1);
      aalpha = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1+1);
      ttau = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1+1+1);
      eeta = param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1+1+1+1);
      ppis =param_gmm(3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1+1+1+1+1:3+num_out+(num_out*(k+1))+(num_out*ndep)+3+k+1+ndep-1+1+1+1+1+num_cov_weights-1+1)';
      
      
if assum_f_delta==1                                            % if N(d) depends on delta (the neighbors matrices are assumed to depend on a parameter vector delta)      
      ddelta= param_gmm(end-1:end);  
      [ N_d, N_d_2, F_d] = neighbors_matrix( ddelta, order );  % call a function that generates the neighbors and neighbors of neighbors matrices which depend on delta
      NN=N_d;
      NN_2=N_d_2;
      Z_out=[NN*log(1+c) NN*r (NN*log(1+c)).^2 (NN*r).^2 (NN*log(1+c)).^3 (N*r).^3 (N*log(1+c)).^4 (N*r).^4 NN_2*log(1+c) NN_2*r (NN_2*log(1+c)).^2 (NN_2*r).^2 (NN_2*log(1+c)).^3 (NN_2*r).^3 (NN_2*log(1+c)).^4 (NN_2*r).^4 zscore(X) X_d hpop zscore(d_bar) zscore(e_bar)];
      Z_br=[NN*log(1+c) NN*r NN_2*log(1+c) NN_2*r log(1+c) r zscore(X) X_d log(hpop(:,1)) hpop(:,2) zscore(d_bar) zscore(e_bar)];
      Z_nat=[V zscore(X) X_d log(hpop(:,1)) hpop(:,2) zscore(d_bar) zscore(e_bar)];
else
     NN=N;
     NN_2=N_2;
     
     Z_out=[NN*log(1+c) NN*r (NN*log(1+c)).^2 (NN*r).^2 (NN*log(1+c)).^3 (N*r).^3 (N*log(1+c)).^4 (N*r).^4 NN_2*log(1+c) NN_2*r (NN_2*log(1+c)).^2 (NN_2*r).^2 (NN_2*log(1+c)).^3 (NN_2*r).^3 (NN_2*log(1+c)).^4 (NN_2*r).^4 zscore(X) X_d hpop];
     Z_br=[NN*log(1+c) NN*r NN_2*log(1+c) NN_2*r log(1+c) r zscore(X) X_d log(hpop(:,1)) hpop(:,2)];
     Z_nat=[V zscore(X) X_d log(hpop(:,1)) hpop(:,2)];  
end
   
 

%Simulated GMM Minimization

    %State Capacity Composite
    if ssigma==1
        s = (l.^aalpha).*((ttau*b).^(1-aalpha));
    else
        s = ( (aalpha.*(l.^((ssigma-1)/ssigma))) + ((1-aalpha).*((ttau*b).^((ssigma-1)/ssigma))) ).^(ssigma/(ssigma-1));
    end
    
    %Non parametric conditional expectation
    yy = (ttheta./aalpha).*l.*((l./s).^(1/ssigma)) - ppsi_1*(NN*s) - X_d*zzet_br;
    xx = [log(1+c) r zscore(X) log(pop)];
    exp_cond_g = nonparametric_conditional( yy, xx, biweight_kernel, truncation_normal, [pphi; bbeta_br], nobin );
    
    
    %Residuals:
    %Propserity equation
    Qt = zeros(n,num_out);
    
    for j=1:num_out
        Qt(:,j) = zscore(p(:,j)) - ((ttheta./aalpha).*l.*s.*((l./s).^(1/ssigma))) - (ppsi_2(j).*(NN*s)) - ([zscore(X) pop]*bbeta_out(((j-1)*k)+j:j*(k+1))) - (X_d*zzet_out((1+((j*ndep)-ndep):j*ndep)));
    end
    
    %Local-level FOC
        q_br = (ttheta./aalpha).*l.*((l./s).^(1/ssigma)) - ppsi_1*(NN*s) - exp_cond_g - X_d*zzet_br;
        
    %National-level FOC    
        
        LS = ((l./s).^(1/ssigma));
        
        %SB = ((s./b).^(1/ssigma));
        
        q_nat=zeros(n,draws);
        
        for i=1:draws
             q_nat(:,i) =q_nat_moment(aalpha, ttau, ssigma, ttheta, ppsi_1, ppsi_2, eeta, num_out, s, LS, NN, exp(V*ppis + OMEGAS(:,i)) );
        end
        
        q_nat_avg =sum(q_nat,2)/draws;
    
     %Residuals All Equations
     
        Qt = [Qt  q_br  q_nat_avg];
        
        Q=Qt';
  
        
  ZZ = [Z_out Z_out Z_out Z_out Z_br Z_nat]';      
        
  Q_gor = [repmat(Q(1,:),size(Z_out,2),1); repmat(Q(2,:),size(Z_out,2),1) ; repmat(Q(3,:),size(Z_out,2),1) ; repmat(Q(4,:),size(Z_out,2),1); repmat(Q(5,:),size(Z_br,2),1); repmat(Q(6,:),size(Z_nat,2),1)];
        
   
  Zq_all = ZZ.*Q_gor;
  
  Zq = sum(Zq_all,2);
 
 objective_fct_gmm = (Zq'/((1/n)*ZOZ))*Zq;
 
 

end

